/*
**  pilib.h - .pi ǂݍ/oCu ver.3.10 (Sep 6, 2004)
**
**  Copyright (C) 1999-2004 MIYASAKA Masaru <alkaid@coral.ocn.ne.jp>
**
**  This software is provided 'as-is', without any express or implied warranty.
**  In no event will the authors be held liable for any damages arising from
**  the use of this software.
**
**  Permission is granted to anyone to use this software for any purpose,
**  including commercial applications, and to alter it and redistribute it
**  freely, subject to the following restrictions:
**
**  1. The origin of this software must not be misrepresented; you must not
**     claim that you wrote the original software. If you use this software
**     in a product, an acknowledgment in the product documentation would be
**     appreciated but is not required.
**
**  2. Altered source versions must be plainly marked as such, and must not
**     be misrepresented as being the original software.
**
**  3. This notice may not be removed or altered from any source distribution.
**
**  ----
**
**  {\tgEFÁû܂܁vŁAł邩Öقł邩킸A
**  ۏ؂Ȃ񋟂܂B {\tgEFA̎gpɂĐ邢Ȃ鑹Q
**  ĂA҂͈؂̐ӔC𕉂Ȃ̂Ƃ܂B
**
**  ȉ̐ɏ]ApAvP[V܂߂āA{\tgEFACӂ
**  ړIɎgpARɉςčĔЕz邱ƂׂĂ̐lɋ܂B
**
**  1. {\tgEFȀoɂċU̕\Ă͂Ȃ܂B
**     ȂIWĩ\tgEFA쐬Ǝ咣Ă͂Ȃ܂B
**     Ȃ{\tgEFA𐻕iŎgpꍇAi̕Ɏӎ
**     ΍KłAK{ł͂܂B
**
**  2. \[XύXꍇ́ÂƂ𖾎Ȃ΂Ȃ܂BIWi
**     ̃\tgEFAłƂU̕\Ă͂Ȃ܂B
**
**  3. \[X̔ЕzA̕\폜A\̓eύX肵Ă
**     Ȃ܂
**
**  ----
**
**  NOTE: Comments are written in Japanese. Sorry.
*/

#ifndef PILIB_H
#define PILIB_H

/* -----------------------------------------------------------------------
**		Basic functions
*/

#include <limits.h>		/* for CHAR_BIT */
#include <stddef.h>		/* for size_t & ptrdiff_t */

#if 0	/* Use Win32-API functions */

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

#define pi_memmove			MoveMemory
#define pi_memcpy			CopyMemory
#define pi_memset(d,c,l)	FillMemory((d),(l),(c))
#define pi_malloc(s)		((pi_voidp)LocalAlloc(LMEM_FIXED,(s)))
#define pi_free(s)			LocalFree((HLOCAL)(s))

#else	/* Use standad C library functions */

#include <stdlib.h>
#include <string.h>

#define pi_memmove			memmove
#define pi_memcpy			memcpy
#define pi_memset			memset
#define pi_malloc			malloc
#define pi_free				free

#endif

/* -----------------------------------------------------------------------
**		Configurations
*/

	/* e퓮ݒ */
#define PI_SUPPORT_LONGJMP				/* longjmp() găG[ */
#define PI_SUPPORT_PROGRESS_CALLBACK 	/* R[obN֐gp\ɂ */

#define PI_READ_SKIP_MACBINARY			/* 擪 MacBinary ǂݔ΂ */
#define PI_READ_SUPPORT_STDIO			/* bWXg[͂̃T|[g */
#define PI_READ_SUPPORT_EXTINFO			/* wb_̊g擾 */
#define PI_READ_SUPPORT_COMMENT			/* eLXg擾 */
#define PI_READ_SUPPORT_READIMAGE		/* pi_read_image() gp\ɂ */
#undef PI_READ_OUTPUT_8BPP_FMT			/*  8bit/pixel `ŏo͂ */

#define PI_WRITE_SUPPORT_STDIO			/* bWXg[o͂̃T|[g */
#define PI_WRITE_SUPPORT_EXTINFO 		/* wb_̊gݒ肷 */
#define PI_WRITE_SUPPORT_COMMENT 		/* eLXgݒ肷 */
#define PI_WRITE_SUPPORT_WRITEIMAGE		/* pi_write_image() gp\ɂ */
#undef PI_WRITE_INPUT_8BPP_FMT			/*  8bit/pixel `œ͂ */

#define PI_CALL_USING_FASTCALL			/* ֐ fastcall Ăяog */
#define PI_INIT_STRUCT_BY_MEMSET 		/* pi_memset() ō\̂ */
#undef PI_WORD_OPERATION_ON_PIXEL		/* 16rbgPʂŃsNZ */
#define PI_WRITE_PUTBITS_FUNC			/* ֐ł̃rbgo̓[`g */

	/* 2pixelȉ̉摜APidl(PITECH.TXT)ɏĂƂ
	 * GR[h^fR[hɂ́Aȉ̃}N #define ܂B
	 * ڂ piwrite.c ̒́u2pixelȉ̉摜̏@v
	 * BɗR̂Ȃ #undef ɂĂƂE߂܂B*/
#undef PI_READ_W2_SPEC_COMPLIANT_DECODING
#undef PI_WRITE_W2_SPEC_COMPLIANT_ENCODING



/* ***********************************************************************
**		Pi format encoding/decoding library (piwrite.c/piread.c)
*/

	/* ftHg̃G[R[h(Ē`\) */
#ifndef PI_OK
#define PI_OK						0		/*  */
#define PI_ERR_NOT_A_PI				1		/* .PIt@Cł͂Ȃ */
#define PI_ERR_INVALID_BITDEPTH		2		/* ȐF[x(4,8 ȊO) */
#define PI_ERR_INVALID_WIDTH		3		/* ȕ(0 or 65535) */
#define PI_ERR_INVALID_HEIGHT		4		/* ȍ(0 or 65535) */
#define PI_ERR_FILE_WRITE			5		/* t@C݃G[ */
#define PI_ERR_FILE_READ			6		/* t@Cǂݍ݃G[ */
#define PI_ERR_END_OF_FILE			7		/* t@CI[o */
#define PI_ERR_OUT_OF_MEMORY		8		/* s */
#define PI_ERR_CALLBACK_CANCELED	9		/* sR[obN֐ɂ钆~ */
#endif

	/* etOȂ */
#define PI_FLAG_NO_COMMENT		0x0001		/* Rg擾Ȃ */
#define PI_FLAG_MISSING_SIG		0x0002		/* t@C擪 "Pi" Ȃ */
#define PI_MODE_NO_PALETTE		0x80		/* ftHgpbggp摜 */
#define PI_TRANSCOLOR_NONE		(-1)		/* FȂꍇ̎wl */

	/* G[p}N */
#ifdef PI_SUPPORT_LONGJMP
	/* setjmp()  longjmp() ɂ@ */
#include <setjmp.h>		/* setjmp() & longjmp() */
#define PI_ISERR(p)     (0)
#define PI_RESETERR(p)
#define PI_CHKERR_RETURN(p)
#define PI_CHKERR_RETURN_VAL(p,r)
#define PI_SETERR_RETURN(p,e)        longjmp((p)->jmpbuf,(e))
#define PI_SETERR_RETURN_VAL(p,e,r)  longjmp((p)->jmpbuf,(e))
#else
	/* ϐ error ̒lȂ珇 return Ă@ */
#define PI_ISERR(p)     ((p)->error!=PI_OK)
#define PI_RESETERR(p)  ((p)->error=PI_OK)
#define PI_CHKERR_RETURN(p) \
            do { if (PI_ISERR(p)) return; } while (0)
#define PI_CHKERR_RETURN_VAL(p,r) \
            do { if (PI_ISERR(p)) return (r); } while (0)
#define PI_SETERR_RETURN(p,e) \
            do { if (!PI_ISERR(p)) (p)->error=(e); return; } while (0)
#define PI_SETERR_RETURN_VAL(p,e,r) \
            do { if (!PI_ISERR(p)) (p)->error=(e); return (r); } while (0)
#endif /* PI_SUPPORT_LONGJMP */

	/* s̃oCgvZ}N */
#ifdef PI_READ_OUTPUT_8BPP_FMT
#define pi_read_get_rowbytes(p) ((p)->width)
#else
#define pi_read_get_rowbytes(p) \
            (((p)->bitdepth == 8) ? (p)->width : ((pi_uint32)(p)->width+1)/2)
#endif

	/* piread.c / piwrite.c ł̂ݎQƂ}N */
#ifdef PI_INTERNAL

	/* FASTCALL ĂяoK */
#undef FASTCALL
#ifdef PI_CALL_USING_FASTCALL
#if defined(__GNUC__) && defined(__i386__)			/* gcc (on i386) */
#define FASTCALL  __attribute__((regparm(3)))
#elif defined(_MSC_VER) || defined(__BORLANDC__)	/* MS-C or BCC */
#define FASTCALL  __fastcall
#endif
#endif /* PI_CALL_USING_FASTCALL */
#ifndef FASTCALL
#define FASTCALL
#endif

	/* ϐ/^̃rbg */
#define bitsof(x)	(sizeof(x) * CHAR_BIT)

#endif /* PI_INTERNAL */

	/* typedef's */
typedef char           pi_char;		/* signed or unsigned */
typedef unsigned char  pi_byte;
typedef int            pi_int;
typedef unsigned int   pi_uint;
typedef short          pi_int16;
typedef unsigned short pi_uint16;
typedef long           pi_int32;
typedef unsigned long  pi_uint32;

typedef unsigned int pi_bitbuf;		/* unsigned  16bit ȏ */
typedef size_t       pi_size_t;
typedef ptrdiff_t    pi_ptrdif_t;

typedef void      * pi_voidp;
typedef pi_char   * pi_charp;
typedef pi_byte   * pi_bytep;
typedef pi_int    * pi_intp;
typedef pi_uint   * pi_uintp;
typedef pi_int16  * pi_int16p;
typedef pi_uint16 * pi_uint16p;
typedef pi_int32  * pi_int32p;
typedef pi_uint32 * pi_uint32p;
typedef pi_bytep  * pi_bytepp;

typedef struct pi_struct   pi_struct;
typedef struct pi_struct * pi_structp;
typedef struct pi_text     pi_text;
typedef struct pi_text   * pi_textp;
typedef struct pi_stdio    pi_stdio;
typedef struct pi_stdio  * pi_stdiop;

typedef pi_size_t (*pi_iofncp)(pi_structp);
typedef pi_int (*pi_progfncp)(pi_structp, pi_uint, pi_uint);

	/* pbgpJ[\(ftHg`) */
#ifndef PI_COLOR_DEFINED
#define PI_COLOR_DEFINED
typedef struct pi_color {
	pi_byte		red;
	pi_byte		green;
	pi_byte		blue;
} pi_color;
#endif
typedef pi_color * pi_colorp;

	/* bW I/O ɂo̓T|[gp\ */
#ifdef PI_READ_SUPPORT_STDIO
#include <stdio.h>
struct pi_stdio {
	FILE		*fp;			/* o̓Xg[ */
	pi_byte		iobuf[4096];	/* o̓obt@ */
};
#endif

	/* Rgێp\ */
#ifdef PI_READ_SUPPORT_COMMENT
struct pi_text {
	pi_textp	next;		/* ւ̃|C^ */
	pi_uint32	size;		/* eLXg̃TCY */
	pi_charp	text;		/* eLXg */
};
#endif

	/* pi_struct \ */
struct pi_struct {
		/* G[pϐ */
#ifdef PI_SUPPORT_LONGJMP
	jmp_buf		jmpbuf;				/* setjmp() / longjmp() pReLXg */
#else
	pi_int		error;				/* G[R[h */
#endif
		/* .PIt@Cwb_񁕊e摜 */
	pi_uint		width, height;		/* 摜̃TCY */
	pi_uint		colors;				/* F(16 or 256) */
	pi_byte		bitdepth;			/* F[x(4 or 8) */
	pi_byte		aspect_x, aspect_y;	/* AXyNg */
	pi_byte		mode;				/* 摜[h */
	pi_byte		machine[4];			/* @펯ʎq(GR[_) */

		/* I/O ֌W */
	pi_iofncp	iofunc;				/* I/O ֐ */
	pi_voidp	ioptr;				/* I/O ֐pėp|C^ */
	pi_bytep	iobufptr;			/* I/O obt@̃|C^ */
	pi_size_t	iobufcnt;			/* I/O obt@̎coCg */
	pi_bitbuf	bitbuf;				/* rbgobt@ */
	pi_uint		bitcnt;				/* rbgobt@̎crbg */

		/* Ɨp̈EƗpϐ */
	pi_bytep	clrtable;			/* J[e[u */
	pi_bytep	clrcode;			/* J[R[he[u */
	pi_bytep	clrcodelen;			/* J[R[h̒ */
	pi_bytep	lencode;			/* AR[he[u */
	pi_bytep	lencodelen;			/* AR[h̒ */

	pi_uint		prevpos;			/* ÖʒuR[h */
	pi_uint		savedpos;			/* ݂̈ʒuR[h */
	pi_uint32	savedlen;			/* ݂̘A */

	pi_bytep	rowbuf;				/* sobt@ */
	pi_bytep	rowptr[4];			/* s̐擪AhX */
	pi_bytep	rowend;				/* s̏I[AhX */
	pi_bytep	currentp;			/* ݂̍s̒ړ_ */
	pi_uint		rownum;				/* ݂̍s̍sԍ (1`height) */
	pi_ptrdif_t	posdiff[6];			/* ʒuR[hɑΉ鑊΃AhX */

		/* .PIt@Cwb_̊g */
#if defined(PI_READ_SUPPORT_EXTINFO) || defined(PI_WRITE_SUPPORT_EXTINFO)
	pi_uint		offset_x, offset_y;	/* 摜̕\Jn_(ItZbg) */
	pi_int		transcolor;			/* FɂȂpbgԍ (0`15/255) */
	pi_int		sigbits;			/* pbg̗Lrbg (1`8) */
	pi_int		colorused;			/* pbg̎gp (1`16/256) */
#endif
		/* eLXg */
#if defined(PI_READ_SUPPORT_COMMENT) || defined(PI_WRITE_SUPPORT_COMMENT)
	pi_text		comment;			/* eLXgobt@ */
#endif
		/* R[obN֐ */
#ifdef PI_SUPPORT_PROGRESS_CALLBACK
	pi_progfncp	progfunc;			/* R[obN֐ */
	pi_voidp	progptr;			/* R[obN֐pėp|C^ */
#endif
};

	/* vg^Cv錾 (piread.c) */
void pi_read_init(pi_structp);
void pi_read_end(pi_structp);
void pi_read_header(pi_structp, pi_uint);
#ifdef PI_READ_SUPPORT_COMMENT
void pi_read_get_comment(pi_structp, pi_charp, pi_int);
#endif
void pi_read_palette(pi_structp, pi_colorp);
void pi_read_row_init(pi_structp);
int pi_read_row(pi_structp, pi_bytep);
#ifdef PI_READ_SUPPORT_READIMAGE
void pi_read_image(pi_structp, pi_bytepp);
#endif
#ifdef PI_READ_SUPPORT_STDIO
void pi_read_init_io(pi_structp, FILE *);
void pi_read_end_io(pi_structp);
#endif

	/* vg^Cv錾 (piwrite.c) */
void pi_write_init(pi_structp);
void pi_write_end(pi_structp);
void pi_write_header(pi_structp);
void pi_write_palette(pi_structp, pi_colorp /*, pi_int*/);
void pi_write_row_init(pi_structp);
int pi_write_row(pi_structp, pi_bytep);
#ifdef PI_WRITE_SUPPORT_WRITEIMAGE
void pi_write_image(pi_structp, pi_bytepp);
#endif
#ifdef PI_WRITE_SUPPORT_STDIO
void pi_write_init_io(pi_structp, FILE *);
void pi_write_end_io(pi_structp);
#endif

#endif /* PILIB_H */
